﻿using System;
using NetOffice;
using NetOffice.Attributes;
namespace NetOffice.MSProjectApi.Enums
{
	 /// <summary>
	 /// SupportByVersion MSProject 11, 12, 14
	 /// </summary>
	 ///<remarks> MSDN Online Documentation: http://msdn.microsoft.com/en-us/en-us/library/office/ff866160(v=office.14).aspx </remarks>
	[SupportByVersion("MSProject", 11,12,14)]
	[EntityType(EntityType.IsEnum)]
	public enum PjWeekLabel
	{
		 /// <summary>
		 /// SupportByVersion MSProject 11, 12, 14
		 /// </summary>
		 /// <remarks>17</remarks>
		 [SupportByVersion("MSProject", 11,12,14)]
		 pjWeekLabelWeek_mm_dd = 17,

		 /// <summary>
		 /// SupportByVersion MSProject 11, 12, 14
		 /// </summary>
		 /// <remarks>16</remarks>
		 [SupportByVersion("MSProject", 11,12,14)]
		 pjWeekLabelWeek_mm_dd_yy = 16,

		 /// <summary>
		 /// SupportByVersion MSProject 11, 12, 14
		 /// </summary>
		 /// <remarks>89</remarks>
		 [SupportByVersion("MSProject", 11,12,14)]
		 pjWeekLabelWeek_m_dd = 89,

		 /// <summary>
		 /// SupportByVersion MSProject 11, 12, 14
		 /// </summary>
		 /// <remarks>15</remarks>
		 [SupportByVersion("MSProject", 11,12,14)]
		 pjWeekLabelWeek_mmm_dd = 15,

		 /// <summary>
		 /// SupportByVersion MSProject 11, 12, 14
		 /// </summary>
		 /// <remarks>13</remarks>
		 [SupportByVersion("MSProject", 11,12,14)]
		 pjWeekLabelWeek_mmm_dd_yyy = 13,

		 /// <summary>
		 /// SupportByVersion MSProject 11, 12, 14
		 /// </summary>
		 /// <remarks>14</remarks>
		 [SupportByVersion("MSProject", 11,12,14)]
		 pjWeekLabelWeek_mmmm_dd = 14,

		 /// <summary>
		 /// SupportByVersion MSProject 11, 12, 14
		 /// </summary>
		 /// <remarks>12</remarks>
		 [SupportByVersion("MSProject", 11,12,14)]
		 pjWeekLabelWeek_mmmm_dd_yyyy = 12,

		 /// <summary>
		 /// SupportByVersion MSProject 11, 12, 14
		 /// </summary>
		 /// <remarks>92</remarks>
		 [SupportByVersion("MSProject", 11,12,14)]
		 pjWeekLabelWeek_di_mm_dd = 92,

		 /// <summary>
		 /// SupportByVersion MSProject 11, 12, 14
		 /// </summary>
		 /// <remarks>99</remarks>
		 [SupportByVersion("MSProject", 11,12,14)]
		 pjWeekLabelWeek_di_m_dd = 99,

		 /// <summary>
		 /// SupportByVersion MSProject 11, 12, 14
		 /// </summary>
		 /// <remarks>95</remarks>
		 [SupportByVersion("MSProject", 11,12,14)]
		 pjWeekLabelWeek_di_mmm_dd = 95,

		 /// <summary>
		 /// SupportByVersion MSProject 11, 12, 14
		 /// </summary>
		 /// <remarks>91</remarks>
		 [SupportByVersion("MSProject", 11,12,14)]
		 pjWeekLabelWeek_ddi_mm_dd = 91,

		 /// <summary>
		 /// SupportByVersion MSProject 11, 12, 14
		 /// </summary>
		 /// <remarks>98</remarks>
		 [SupportByVersion("MSProject", 11,12,14)]
		 pjWeekLabelWeek_ddi_m_dd = 98,

		 /// <summary>
		 /// SupportByVersion MSProject 11, 12, 14
		 /// </summary>
		 /// <remarks>94</remarks>
		 [SupportByVersion("MSProject", 11,12,14)]
		 pjWeekLabelWeek_ddi_mmm_dd = 94,

		 /// <summary>
		 /// SupportByVersion MSProject 11, 12, 14
		 /// </summary>
		 /// <remarks>90</remarks>
		 [SupportByVersion("MSProject", 11,12,14)]
		 pjWeekLabelWeek_ddd_mm_dd = 90,

		 /// <summary>
		 /// SupportByVersion MSProject 11, 12, 14
		 /// </summary>
		 /// <remarks>100</remarks>
		 [SupportByVersion("MSProject", 11,12,14)]
		 pjWeekLabelWeek_ddd_mm_dd_yy = 100,

		 /// <summary>
		 /// SupportByVersion MSProject 11, 12, 14
		 /// </summary>
		 /// <remarks>88</remarks>
		 [SupportByVersion("MSProject", 11,12,14)]
		 pjWeekLabelWeek_ddd_dd = 88,

		 /// <summary>
		 /// SupportByVersion MSProject 11, 12, 14
		 /// </summary>
		 /// <remarks>103</remarks>
		 [SupportByVersion("MSProject", 11,12,14)]
		 pjWeekLabelWeek_ddd_ww = 103,

		 /// <summary>
		 /// SupportByVersion MSProject 11, 12, 14
		 /// </summary>
		 /// <remarks>97</remarks>
		 [SupportByVersion("MSProject", 11,12,14)]
		 pjWeekLabelWeek_ddd_m_dd = 97,

		 /// <summary>
		 /// SupportByVersion MSProject 11, 12, 14
		 /// </summary>
		 /// <remarks>93</remarks>
		 [SupportByVersion("MSProject", 11,12,14)]
		 pjWeekLabelWeek_ddd_mmm_dd = 93,

		 /// <summary>
		 /// SupportByVersion MSProject 11, 12, 14
		 /// </summary>
		 /// <remarks>101</remarks>
		 [SupportByVersion("MSProject", 11,12,14)]
		 pjWeekLabelWeek_ddd_mmm_dd_yyy = 101,

		 /// <summary>
		 /// SupportByVersion MSProject 11, 12, 14
		 /// </summary>
		 /// <remarks>96</remarks>
		 [SupportByVersion("MSProject", 11,12,14)]
		 pjWeekLabelWeek_ddd_mmmm_dd = 96,

		 /// <summary>
		 /// SupportByVersion MSProject 11, 12, 14
		 /// </summary>
		 /// <remarks>102</remarks>
		 [SupportByVersion("MSProject", 11,12,14)]
		 pjWeekLabelWeek_ddd_mmmm_dd_yyy = 102,

		 /// <summary>
		 /// SupportByVersion MSProject 11, 12, 14
		 /// </summary>
		 /// <remarks>87</remarks>
		 [SupportByVersion("MSProject", 11,12,14)]
		 pjWeekLabelWeekDayOfMonth_dd = 87,

		 /// <summary>
		 /// SupportByVersion MSProject 11, 12, 14
		 /// </summary>
		 /// <remarks>68</remarks>
		 [SupportByVersion("MSProject", 11,12,14)]
		 pjWeekLabelWeekFromEnd_ww = 68,

		 /// <summary>
		 /// SupportByVersion MSProject 11, 12, 14
		 /// </summary>
		 /// <remarks>67</remarks>
		 [SupportByVersion("MSProject", 11,12,14)]
		 pjWeekLabelWeekFromEnd_Www = 67,

		 /// <summary>
		 /// SupportByVersion MSProject 11, 12, 14
		 /// </summary>
		 /// <remarks>43</remarks>
		 [SupportByVersion("MSProject", 11,12,14)]
		 pjWeekLabelWeekFromEnd_Week_ww = 43,

		 /// <summary>
		 /// SupportByVersion MSProject 11, 12, 14
		 /// </summary>
		 /// <remarks>70</remarks>
		 [SupportByVersion("MSProject", 11,12,14)]
		 pjWeekLabelWeekFromStart_ww = 70,

		 /// <summary>
		 /// SupportByVersion MSProject 11, 12, 14
		 /// </summary>
		 /// <remarks>69</remarks>
		 [SupportByVersion("MSProject", 11,12,14)]
		 pjWeekLabelWeekFromStart_Www = 69,

		 /// <summary>
		 /// SupportByVersion MSProject 11, 12, 14
		 /// </summary>
		 /// <remarks>42</remarks>
		 [SupportByVersion("MSProject", 11,12,14)]
		 pjWeekLabelWeekFromStart_Week_ww = 42,

		 /// <summary>
		 /// SupportByVersion MSProject 11, 12, 14
		 /// </summary>
		 /// <remarks>104</remarks>
		 [SupportByVersion("MSProject", 11,12,14)]
		 pjWeekLabelWeekNumber_dd_ww = 104,

		 /// <summary>
		 /// SupportByVersion MSProject 11, 12, 14
		 /// </summary>
		 /// <remarks>50</remarks>
		 [SupportByVersion("MSProject", 11,12,14)]
		 pjWeekLabelWeekNumber_ww = 50,

		 /// <summary>
		 /// SupportByVersion MSProject 11, 12, 14
		 /// </summary>
		 /// <remarks>35</remarks>
		 [SupportByVersion("MSProject", 11,12,14)]
		 pjWeekLabelNoDateFormat = 35
	}
}